local script = nil

local function maybe_pull_item(name, amount)
	amount = amount or 1
	if count(name) < amount then
		async_post_page("/storage.php", { action = "pull", whichitem1 = get_itemid(name), howmany1 = amount - count(name), pwd = session.pwd, ajax = 1 })
		if amount > 1 and count(name) < amount then
			error("Couldn't pull " .. tostring(amount) .. "x " .. tostring(name))
		end
	end
end

local function adv_space_zone(zoneid)
	script.ensure_buffs { "Fat Leon's Phat Loot Lyric", "Leash of Linguini", "Empathy" }
	script.heal_up()
	script.ensure_mp(100)
	result, resulturl, advagain = autoadventure {
		zoneid = zoneid,
		noncombatchoices = {
			["An E.M.U. for Y.O.U."] = "Hand over the parts",
		},
	}
end

local function use_map(mapname, mapzonetitle, choices)
	local pt, url = use_item(mapname)()
	pt, url = get_page("/choice.php")
	result, resulturl, advagain = handle_adventure_result(pt, url, "?", nil, nil, function (advtitle, choicenum, pt)
		if advtitle == mapzonetitle then
			for c in table.values(choices) do
				if pt:contains(c) then
					return c
				end
			end
		end
	end)
end

local function ronaldus(choices)
	if have("Map to Safety Shelter Ronald Prime") then
		use_map("Map to Safety Shelter Ronald Prime", "Deep Inside Ronald, Baby", choices)
	else
		adv_space_zone(265)
	end
end

local function grimacite(choices)
	if have("Map to Safety Shelter Grimace Prime") then
		use_map("Map to Safety Shelter Grimace Prime", "Deep Inside Grimace, Bow Chick-a Bow Bow", choices)
	else
		adv_space_zone(266)
	end
end

local space_href = add_automation_script("automate-spaaace", function ()
	if not autoattack_is_set() then
		error "Set a macro on autoattack to use for scripting this quest."
	end
	script = get_automation_scripts()
	maybe_pull_item("sea salt scrubs")
	maybe_pull_item("spangly mariachi pants")
	script.set_familiar "Scarecrow with spangly mariachi pants"
	equip_item("spangly mariachi pants", "familiarequip")
	equip_item("flaming pink shirt", "shirt")
	local function run_turns()
		advagain = false
		if advs() == 0 then
			return "Out of adventures.", requestpath
		end
		if not buff("Transpondent") then
			return "Use another transponder.", requestpath
		end
		if not have("E.M.U. Unit") then
			if not have("spooky little girl") then
				if not have("E.M.U. rocket thrusters") then
					ronaldus { "Take a Look Around", "Try the Swimming Pool", "To the Left, to the Left", "Take the Red Door", "Step through the Glowy-Orange Thing" }
					if have("E.M.U. rocket thrusters") then
						advagain = true
					end
				elseif not have("E.M.U. joystick") then
					ronaldus { "Take a Look Around", "Try the Swimming Pool", "Right as Rain", "Crawl through the Ventilation Duct", "Step through the Glowy Thing" }
					if have("E.M.U. joystick") then
						advagain = true
					end
				elseif not have("E.M.U. harness") then
					grimacite { "Down the Hatch!", "Check out the Coat Check", "Exit, Stage Left", "Be the Duke of the Hazard", "Enter the Transporter" }
					if have("E.M.U. harness") then
						advagain = true
					end
				elseif not have("E.M.U. helmet") then
					grimacite { "Down the Hatch!", "Check out the Coat Check", "Stage Right, Even", "Try the Starboard Door", "Step Through the Transporter" }
					if have("E.M.U. helmet") then
						advagain = true
					end
				else
					adv_space_zone(266)
					advagain = have("spooky little girl")
				end
			else
				if not have_equipped("spooky little girl") then
					equip_item("spooky little girl", "offhand")
					advagain = have_equipped("spooky little girl")
				else
					adv_space_zone(266)
					if have("E.M.U. Unit") then
						advagain = true
					end
				end
			end
		else
			if not have_equipped("E.M.U. Unit") then
				equip_item("E.M.U. Unit", "acc1")
				advagain = have_equipped("E.M.U. Unit")
			else
				result, resulturl, advagain = autoadventure { zoneid = 267 }
				result = add_colored_message_to_page(result, "TODO: fix the generator", "darkorange")
				return result, resulturl
			end
		end
		if advagain then
			return run_turns()
		else
			return result, resulturl
		end
	end
	return run_turns()
end)

add_printer("/spaaace.php", function ()
	if character["enable ascension automation"] ~= "yes" or ascensionstatus() ~= "Aftercore" or character["enable experimental implementations"] ~= "yes" then
		return
	end
	text = text:gsub([[(</table></center>)(</body>)]], [[%1<center><a href="]]..space_href { pwd = session.pwd }..[[" style="color: green">{ Automate Space }</a></center>%2]])
end)
